package agent.impl;

import agent.Agent;
import mailbox.Message;

/**
 * Demo Agent, der ein Ping an den Server schickt. Zu Testzwecken, um das
 * Zusammenspiel zu zeigen.
 * User: Standard
 * Date: 04.11.2003
 * Time: 01:03:29
 *
 */
public class PingAgent extends Agent{


    public void run(){

        while (ivRunning){
            sendMessageToServer(new Message( Message.PING));

           try {
                Thread.sleep(500);
            } catch (InterruptedException e) {
                e.printStackTrace();  //To change body of catch statement use Options | File Templates.
            }


            try {
                if(ivRunning){
                    Message lvMessage = getNextMessage();
                    log("Absender: " + lvMessage.getAbsender());
                    log("Betreff:  " + lvMessage.getBetreff() + "\n");
                }
            } catch (Exception e) {
                log("Fehler beim Nachrichtenauslesen: " + e.getMessage() + "\n");
            }

        }
    }

    private void log(String message){
        System.out.println("SimpleAgent "+ivName + " -> " + message);
    }

}
