package editor;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: charadan1
 * Date: 14.10.2003
 * Time: 03:25:06
 * To change this template use Options | File Templates.
 */
public class AntriebsTyp {
    private String name= new String();
    private int gewicht=0;
    private Hashtable passierbarkeit = new Hashtable(); // hier kommen fr alle Gelndearten rein, ob dieser Antrieb passieren kann
    private Hashtable geschwindigkeit = new Hashtable(); // und auch die Geschwindigkeit ist vom Gelnde abhngig
    private Hashtable energieverbrauch = new Hashtable(); // energieverbrauch fr das berqueren eines bestimmten Gelndes
    private static Vector antriebe= new Vector();


    /**Ereugt einen Anrieb mit dem Gewicht 0
     *@param name Der Name des Antriebs
     */
    public AntriebsTyp(String name){
        this.name = new String(name);
        antriebe.add(this);//Antrieb bekannt machen
    }


    /**Erzeugt einen Antrieb mit whlbarem Gewicht
     *@param name Der Name des Antriebs
     *@param gewicht Das Gewicht des Antriebs
     */
    public AntriebsTyp(String name, int gewicht ){
        this.name = new String(name);
        this.gewicht = gewicht;
        antriebe.add(this);
    }

    /**Gibt einen Array mit allen bisher erzeugten Antrieben zurck
     *@return Ein Array, das alle bisher erzeugten Antriebe enthlt
     */
    public static AntriebsTyp[] getantriebe(){
        //return  antriebe.clone();
        return (AntriebsTyp[]) antriebe.toArray(new AntriebsTyp[antriebe.size()]);
    }

    /**Lscht einen Antrieb aus der Liste der bekannten Antriebe
     *@param antrieb Der zu lschende Antrieb
     */
    public static void deleteantrieb(AntriebsTyp antrieb){
        antriebe.remove(antrieb);
    }

    /**Gibt den Namen des Antriebs zurck
     *@return der Name des Antriebs
     */
    public String getname(){
        return name;
    }

    /**Weist dem Antrieb einen neuen Namen zu
     *@param name Ein String, welcher den neuen Namen des Antriebs enthlt
     */
    public void setname(String name){
        this.name = new String(name);
    }

    /**Gibt das Gewicht des Antriebs zurck
     *@return das Gewicht des Antriebs
     */
    public int getgewicht(){
        return gewicht;
    }

    /** ndert das Gewicht des Antriebs
     *@param gewicht Das neue Gewicht des Antriebs
     */
    public void setgewicht(int gewicht){
        this.gewicht = gewicht;
    }

    /**Legt fest, ob der Antrieb ein bestimmtes Gel&auml;nde passieren kann
     *@param passierbar Passierbarkeit
     *@param gelaende die Gelaendeart
     */
    public void setpassierbarkeit(boolean passierbar, Gelaende gelaende){
        passierbarkeit.put(gelaende, Boolean.valueOf(passierbar));
    }
    
    /**
     *Gibt zurck, ob der Antrieb das entsprechende Gelnde passieren kann
     *@param gelaende Das gew&uuml;nschte Gelnde
     *@return die Passierbarkeit
     */
    public boolean getpassierbarkeit(Gelaende gelaende){
        return ((Boolean)(passierbarkeit.get(gelaende))).booleanValue();
    }

    /**Legt die Geschwindigkeit des Antriebs auf einem bestimmten Gel&auml;nde
     *fest
     *@param speed die Geschwindigkeit
     *@param gelaende das Gel&auml;nde
     */
    public void setgeschwindigkeit(int speed, Gelaende gelaende){
        geschwindigkeit.put(gelaende, new Integer(speed));
    }

    /**Gibt die Geschwindigkeit des Antriebs auf dem angegebenen Gel&auml;nde
     *zurck
     *@param gelaende das gew&uuml;nschte Gel&auml;nde
     *@return die Geschwindigkeit
     */
    public int getgeschwindigkeit(Gelaende gelaende){
       return ((Integer)(geschwindigkeit.get(gelaende))).intValue();
    }

    /**Legt den Energieverbrauch des Antriebs auf einem bestimmten Gel&auml;nde
     *fest
     *@param energie der Energieverbrauch
     *@param gelaende das Gel&auml;nde
     */
    public void setenergieverbrauch(int energie, Gelaende gelaende){
        energieverbrauch.put(gelaende, new Integer(energie));
    }

    /**Gibt den Energieverbrauch des Antriebs auf dem angegebenen Gel&auml;nde
     *zurck
     *@param gelaende das gew&uuml;nschte Gel&auml;nde
     *@return der Energieverbrauch
     */
    public int getenergieverbrauch(Gelaende gelaende){
        return ((Integer)(energieverbrauch.get(gelaende))).intValue();
    }

    /**L&auml;dt einen Antriebstyp anhand seiner ID aus der Datenbank
     *@param aid die ID des Antriebs in der Datenbank
     *@return der geladene Antriebstyp
     */
    public static AntriebsTyp loadAntriebsTyp(int aid) {
    	Sql sql = new Sql();
	ResultSet rs = sql.select(
		"SELECT *\n" +
		"FROM antrieb\n"+
		"WHERE aid = " + aid + ";");
	String dbName;
	AntriebsTyp ret = null;
	try {
            rs.first();
            dbName = rs.getString("name");
            Enumeration enum = antriebe.elements();
            while (enum.hasMoreElements()) {
                AntriebsTyp at = (AntriebsTyp) enum.nextElement();
                if (at.getname().equals(dbName)) {
                    return at;
                } //Ende if
            } //Ende while
            System.out.println(aid+dbName + rs.getInt("gewicht"));
            ret = new AntriebsTyp(dbName, rs.getInt("gewicht"));
            //Passierbarkeiten, Geschwindigkeiten und Energieverbrauch ziehen:
            rs = sql.select(
                "SELECT p.passierbarkeit passierbarkeit, p.geschwindigkeit geschwindigkeit, p.energieverbrauch energieverbrauch, g.name name\n" +
                "FROM passierbarkeit p, gelaende g\n" +
                "WHERE (p.aid = " + aid + ")" +
                "	AND (p.gid = g.gid);"
            );

			rs.beforeFirst();
			while (rs.next()) {
				String gelaendeName = rs.getString("name");
				Gelaende g = Gelaende.getgelaende(gelaendeName);
				if (g != null){
					ret.passierbarkeit.put(g, Boolean.valueOf(rs.getString("passierbarkeit")));
					ret.geschwindigkeit.put(g, new Integer(rs.getInt("geschwindigkeit")));
					ret.energieverbrauch.put(g, new Integer(rs.getInt("energieverbrauch")));
				}//Ende if
			}//Ende while
		} catch (SQLException e) {
			e.printStackTrace();
		}//Ende try...catch

		return ret;
	} //Ende getAntriebsTyp

    private static void log(String message){
        System.out.println("ANTRIEBSTYP *************************** -> " + message);
    }

}//Ende class AntriebsTyp
