package editor;

import java.awt.*;
import java.util.Vector;
import java.sql.*;
import java.util.Enumeration;
/**
 * Diese Klasse beschreibt Gelndeobjekte
 */

public class Gelaende {
  Sql db= new Sql();

  private String name = new String();
  private Image bild;
  private int gid;
  private int laenge; // auf Spielfeld
  private int breite; // auf Spielfeld
  private int hoehe;
  private static Vector gelaendearten = new Vector();  // der Vector Gelndearten dient als Container fr alle Gelndeobjekte
  /**
   * Laden eines Gelndes aus der Datenbank in ein Objekt
   * @param name Name des zu ladenden Gelndes
   */

  public Gelaende(String name) {
    this.gid = gid;
    this.name = name;
    ResultSet result = db.select("select * from gelaende where name='" + name + "'");
    try {
      result.next();
      bild = (Toolkit.getDefaultToolkit().getImage(result.getString("bild")));
      gid = result.getInt("gid");
      laenge=result.getInt("laenge");
      breite=result.getInt("breite");
      hoehe=result.getInt("hoehe");
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }

     this.name = name;
    gelaendearten.add(this);
  }

  /**
   * Methode zum Suchen eines Gelndeobjektes
   * @param suchname der Name des zu suchenden Gelndes
   * @return Gelndeobjekt, nach dem gesucht wurde
   */

  public static Gelaende getgelaende(String suchname) {
    Enumeration e = gelaendearten.elements();
    Gelaende g, returner;
    returner=null;
    while(e.hasMoreElements()){
      g=((Gelaende)e.nextElement());
      if(g.getname().equals(suchname)){
        returner = g;
      }
    }
    return returner;
  }

  /**
   * Methode zum Lschen eines Gelndeobjektes
   * @param gelaende Gelndeobjekt, welches gelscht werden soll
   */

  public static void deletegelaendeart(Gelaende gelaende) {
    gelaendearten.remove(gelaende);
  }

  /**
   * Ausgabe des Namens dieses Gelndes
   * @return Name des Gelndes
   */
  public String getname() {
    return new String(name);
  }

/**
  * Ausgabe der Breite dieses Gelndes
  * @return Breite des Gelndes
  */
  public int getbreite() {
    return breite;
  }

  /**
   * Ausgabe der Hhe dieses Gelndes
   * @return Hhe des Gelndes
   */
  public int gethoehe(){
    return hoehe;
  }

  /**
   * Ausgabe der Lnge dieses Gelndes
   * @return Lnge des Gelndes
   */

  public int getlaenge() {
    return laenge;
  }

 /**
  * Ausgabe des Namens dieses Gelnde
  * @return Name des Gelndes
  */
  public Image getbild() {
    return bild;
  }

  // Mainmethode nur zu Testzwecken
  public static void main(String[] args){
    new Gelaende("Wald");
    new Gelaende("Baum");
    Gelaende g=Gelaende.getgelaende("Baum");
    System.out.println(g.getlaenge()+" - "+g.getbreite());
    if (g.getbild()!=null)System.out.println(g.getbild());
          else System.out.println("nope");
  }

}
